# $Id: Util.pm 29030 2009-10-18 10:31:57Z wsl $
# $URL: https://infix.uvt.nl/its-id/trunk/sources/aselect-perl/lib/Aselect/Util.pm $

use utf8;
use strict;
use warnings FATAL => 'all';;

package Aselect::Util;

use URI::Escape;
use MIME::Base64;
use Exporter 'import';

our @EXPORT = qw(aselect_split aselect_join aselect_url aselect_valid aselect_encode aselect_decode);

my $timeout = 2;

sub aselect_split {
	my %items;
	foreach(split('&', shift)) {
		my ($key, $val) = split(/=/o, $_, 2);
		$val = uri_unescape($val) if defined $val;
		$items{$key} = $val
	}
	return \%items;
}

sub aselect_join {
	my @items;
	while(@_) {
		my $val = pop;
		my $key = pop;
		die "undefined/missing key" unless defined $key;
		push @items, defined $val ? "$key=".uri_escape($val) : $key;
	}
	return join('&', @items)
}

sub aselect_encode {
	return encode_base64(aselect_join(@_), '')
}

sub aselect_decode {
	return aselect_split(decode_base64($_[0]))
}

sub aselect_valid {
	foreach(@_) {
		return unless defined;
		return if /[^ -~]/;
	}
	return 1
}

sub aselect_url {
	my ($url, $q) = @_;
	my $sep = index($url, '?') == -1 ? '?' : '&';
	my @ret = ($url);
	while(my ($key, $val) = each(%$q)) {
		push @ret, $sep, $key, '=', uri_escape($val);
		$sep = '&';
	}
	return join('', @ret)
}

1;
